// Generated by CoffeeScript 1.10.0
(function() {
  var basic, detailed, production;

  basic = function(basedir) {
    return {
      basedir: basedir,
      levels: ['trace', 'info', 'error', 'warn'],
      destinations: [
        {
          appender: {
            type: 'console'
          },
          levels: ['trace', 'error', 'info', 'warn']
        }
      ]
    };
  };

  production = function(basedir) {
    var conf;
    conf = basic(basedir);
    conf.destinations.push({
      appender: {
        type: 'file',
        filename: basedir + "/full.log"
      },
      levels: conf.levels
    });
    return conf;
  };

  detailed = function(basedir) {
    var additionalLevels, appender, conf, i, j, k, len, len1, len2, level, ref;
    conf = basic(basedir);
    additionalLevels = ['debug'];
    for (i = 0, len = additionalLevels.length; i < len; i++) {
      level = additionalLevels[i];
      conf.levels.push(level);
    }
    for (j = 0, len1 = additionalLevels.length; j < len1; j++) {
      level = additionalLevels[j];
      ref = conf.destinations;
      for (k = 0, len2 = ref.length; k < len2; k++) {
        appender = ref[k];
        appender.levels.push(level);
      }
    }
    conf.destinations.push({
      appender: {
        type: 'file',
        filename: basedir + "/full.log"
      },
      levels: ['trace', 'error', 'info', 'debug', 'warn']
    });
    conf.destinations.push({
      appender: {
        type: 'file',
        filename: basedir + "/error.log"
      },
      levels: ['error', 'warn']
    });
    conf.destinations.push({
      appender: {
        type: 'file',
        filename: basedir + "/trace.log"
      },
      levels: ['trace']
    });
    return conf;
  };

  module.exports = {
    basic: basic,
    production: production,
    detailed: detailed
  };

}).call(this);
